@echo off
echo Firmware patching script for T-CHL7DEUC 2005.0 firmware
echo release #1.05 / 2011-10-26 by geo650.
echo =========================================================
echo.
echo Ensure T-CHL7DEUC.exe file (original firmware) is present
echo in the same directory together with this script.
echo.
echo WARNING! Please STOP in case of any error.
echo The whole process will take up to 10 minutes.
echo.
echo =========================================================
echo Press [ENTER] to prepare and patch your firmware.
pause>nul
echo.

if not exist T-CHL7DEUC.exe goto :failed
echo unpacking original files...
echo Please Press [Install] button and wait.
T-CHL7DEUC.exe

echo.
echo verifying firmware version...
tools\geopatcher T-CHL7DEUC\image\version_info.txt version_info.tmp scripts\geo1.txt

if ERRORLEVEL 1 goto failed

echo patching exe firmware file...
tools\geopatcher T-CHL7DEUC\image\exe.img.enc new_exe.img.enc scripts\geo2.txt

if ERRORLEVEL 1 goto failed

echo patching appdata firmware file...
tools\geopatcher T-CHL7DEUC\image\appdata.img.enc new_appdata.img.enc scripts\geo3.txt

if ERRORLEVEL 1 goto failed

echo - unsquashing appdata...
tools\unsquashfs.exe new_appdata.img.enc
del new_appdata.img.enc
echo - updating appdata...
xcopy /E/R/Q appdata_files\*.* squashfs-root
echo - squashing appdata...
tools\mksquashfs.exe squashfs-root updated_appdata.img.enc -b 65536 -le -all-root
if ERRORLEVEL 1 goto failed
del /S/F/Q squashfs-root>nul
rd /S/Q squashfs-root>nul

tools\geopatcher updated_appdata.img.enc new_appdata.img.enc scripts\geo4.txt

if ERRORLEVEL 1 goto failed

echo.
echo patching validinfo.txt
tools\geopatcher T-CHL7DEUC\image\validinfo.txt new_validinfo.txt scripts\geo5.txt

if ERRORLEVEL 1 goto failed

echo.
echo swapping files... (3 files are copied)
copy new_validinfo.txt T-CHL7DEUC\image\validinfo.txt >nul
copy new_exe.img.enc T-CHL7DEUC\image\exe.img.enc >nul
copy new_appdata.img.enc T-CHL7DEUC\image\appdata.img.enc >nul

echo deleting temporary file(s)...
del exe_crc_for_validinfo.txt
del appdata_crc_for_validinfo.txt
del new_validinfo.txt
del new_exe.img.enc
del new_appdata.img.enc
del updated_appdata.img.enc
del version_info.tmp

echo.
echo *****************************************************************
echo DONE! Firmare files are prepared. Are you ready to flash your TV?
echo Put T-CHL7DEUC directory on your pendrive and pray ;-)
echo *****************************************************************
echo.

:failed
echo Press [ENTER] to end the script.
pause>nul
